import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
public class NB {
	// Number of Categories
	int NC = 2;
	// Number of Variables
	int NV;
	// Leaning Data
	ArrayList<int[]> LD = new ArrayList<>(); //訓練データの各行をint[]で持ち，訓練データサイズのリストで保持する．
	// Test Data
	ArrayList<int[]> TD = new ArrayList<>();//テストデータの各行をint[]で持ち，テストデータサイズのリストで保持する．
	//頻度表
	double[] ft_c; //N_{X_0=c}の格納先．ft_c[0]=N_{X_0=0}, ft_c[1] = N_{X_0=1}となる(X_0は目的変数を表す)．
	ArrayList<double[][]> ft_ic; //N_{X_i=k,X_0=c}の格納先．例えば，ft_ic[0][0]=N_{X_i=0,X_0=0}, ft_ic[1][0]=N_{X_i=1,X_0=0}となる．
	public NB() throws IOException{
		//データセット入力
		String dataset = "spam";
		System.out.println("Dataset: "+dataset);
		//学習データ読み込み
		readData("data/"+dataset+"/LD.csv", LD);
		//頻度表の生成
		setFrequencyTable();
		//テストデータ読み込み
		readData("data/"+dataset+"/TD.csv", TD);
		//NBのパラメータ学習
		ArrayList<HashMap<Integer, Double>> parameters = getParameters();
		//学習したNBでテストデータを分類
		classification(parameters);
	}

	// 変数自身とその親の値を鍵としてその条件付き確率パラメータを返すようなHashMapを，各変数ごとにArrayListで繋いだものを返す関数
	private ArrayList<HashMap<Integer, Double>> getParameters(){






	}

	//パラメータを用いてテストデータの分類をし，その正答率を表示する．
	private void classification(ArrayList<HashMap<Integer, Double>> parameters){
		double num_correct_prediction = 0;
		for(int d = 0; d < TD.size(); ++d){






			//正答回数測定
			if(predictedClass == TD.get(d)[NV - 1]){
				num_correct_prediction++;
			}
		}
		//正答率表示
		System.out.println("Classification accuracy: "+num_correct_prediction / (double)TD.size());
	}

	// データ読み込み
	private void readData(String DataBaseName, ArrayList<int[]> RD) throws IOException{
		BufferedReader br = new BufferedReader(new FileReader(new File(DataBaseName)));
		ArrayList<String[]> tRD = new ArrayList<String[]>();
		br.readLine();
		String line = br.readLine();
		NV = line.split(",").length;
		while(line != null){
			String[] data = line.split(",").clone();
			tRD.add(data);
			line = br.readLine();
		}
		for(int i = 0; i < tRD.size(); ++i){
			RD.add(new int[NV]);
			for(int j = 0; j < NV; ++j){
				RD.get(i)[j] = Integer.parseInt(tRD.get(i)[j]);
			}
		}
		br.close();
	}

	//N_{X_0=c}とN_{X_i=k,X_0=c}をそれぞれft_c，ft_icに格納する関数
	private void setFrequencyTable(){
		//初期化
		ft_c = new double[NC];
		ft_ic = new ArrayList<>();
		for(int i = 0; i < NV - 1; ++i){
			ft_ic.add(new double[NC][NC]);
		}
		//ft_c, ft_icを計算
		for(int d = 0; d < LD.size(); ++d){






		}
	}

	public static void main(String[] args) throws IOException {
		new NB();
	}
}
